﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;

namespace CollectionsTrying
{
    class Program
    {
        static void Main(string[] args)
        {
            //Collections();
            //Sorting();
            Student st1 = new Student(1, "Anders");
            Student st2 = new Student(2, "John");
            Student st3 = new Student(3, "Abraham");
            List<Student> students = new List<Student> { st2, st3, st1 };
            students.Sort();
            int index = students.BinarySearch(st3);
            Console.WriteLine("Student: " + st3 + " is in index " + index);
            Student st4 = new Student(4, "Billy");
            index = students.BinarySearch(st4);
            Console.WriteLine("Student: " + st4 + " is in index " + index);
        }

        private static void Sorting()
        {
            Student st1 = new Student(1, "Anders");
            Student st2 = new Student(2, "John");
            Student st3 = new Student(3, "Abraham");
            List<Student> students = new List<Student> {st2, st3, st1};
            Console.WriteLine("Not sorted: " + String.Join(", ", students));
            students.Sort();
            Console.WriteLine("Sorted by id: " + String.Join(", ", students));
            students.Sort(StudentNameComparer.Instance);
            Console.WriteLine("Sorted by name: " + String.Join(", ", students));
            students.Sort((student1, student2) => student2.CompareTo(student1));
            Console.WriteLine("Sorted by Id reverse: " + String.Join(", ", students));
        }

        private static void Collections()
        {
            Console.WriteLine("Default capacity of a List: " + new List<int>().Capacity);
            IList<String> names = new[] { "Anders", "John", "Michael", "Peter" };
            foreach (String name in names)
            {
                Console.WriteLine(name);
            }

            IEnumerator<String> enumerator = names.GetEnumerator();
            while (enumerator.MoveNext())
            {
                String name = enumerator.Current;
                Console.WriteLine(name);
            }

            IList<String> namesReadOnly = new ReadOnlyCollection<string>(names);
            names.Add("Brian");

            IDictionary<String, String> dict = new Dictionary<string, string>();
            dict["first"] = "number one";
            dict["second"] = "number two";
            dict["three"] = "number three";
            foreach (String key in dict.Keys)
            {
                Console.WriteLine(key + ": " + dict[key]);
            }
            foreach (KeyValuePair<String, String> pair in dict)
            {
                // KeyValuePair is a struct (not at class)
                Console.WriteLine(pair.Key + ": " + pair.Value);
            }
        }
    }
}
