﻿using System;

namespace CollectionsTrying
{
    public class Student : IComparable<Student>, IEquatable<Student>
    {
        public int Id { get; set; }
        public String Name { get; set; }

        public Student(int id, string name)
        {
            Id = id;
            Name = name;
        }

        public override string ToString()
        {
            return Id + ": " + Name;
        }

        public int CompareTo(Student other)
        {
            return this.Id - other.Id;
        }

        public bool Equals(Student other)
        {
            if (ReferenceEquals(null, other)) return false;
            if (ReferenceEquals(this, other)) return true;
            return Id == other.Id;
        }

        public override bool Equals(object obj)
        {
            if (ReferenceEquals(null, obj)) return false;
            if (ReferenceEquals(this, obj)) return true;
            if (obj.GetType() != this.GetType()) return false;
            return Equals((Student)obj);
        }

        public override int GetHashCode()
        {
            return Id;
        }
    }
}
