﻿using System.Collections.Generic;

namespace CollectionsTrying
{
    /// <summary>
    /// Singleton design pattern
    /// </summary>
    public class StudentNameComparer : IComparer<Student>
    {
        private static readonly IComparer<Student> Inst = new StudentNameComparer();

        public static IComparer<Student> Instance { get { return Inst; } }

        private StudentNameComparer() { }

        public int Compare(Student x, Student y)
        {
            return x.Name.CompareTo(y.Name);
        }
    }
}
